﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        C1List1.DataSource = getTable()
    End Sub

    Public Function getTable() As DataTable

        Dim dTable As New DataTable
        dTable.Columns.Add(New DataColumn("FName"))
        dTable.Columns.Add(New DataColumn("LName"))
        dTable.Columns.Add(New DataColumn("Date of Birth", GetType(DateTime)))
        dTable.Columns.Add(New DataColumn("Hire Date", GetType(DateTime)))

        Dim dr As DataRow = dTable.NewRow
        dr.ItemArray = New String() {"John", "Smith", Now}
        dTable.Rows.Add(dr)

        dr = dTable.NewRow
        dr.ItemArray = New String() {"Dave", "Richardson"}
        dTable.Rows.Add(dr)

        dr = dTable.NewRow
        dr.ItemArray = New String() {"Tom", "Franklin"}
        dTable.Rows.Add(dr)

        dr = dTable.NewRow
        dr.ItemArray = New String() {"Jason", "Lee", Now.AddDays(30), Now.AddYears(-1)}
        dTable.Rows.Add(dr)

        dr = dTable.NewRow
        dr.ItemArray = New String() {"Henry", "Mckinley", Now}
        dTable.Rows.Add(dr)

        Return dTable
    End Function

    Public Sub ExportData(ByVal exportHeaderCondition As Boolean)

        Dim excelSheet As C1.C1Excel.XLSheet = C1XLBook1.Sheets(0)

        If excelSheet IsNot Nothing Then

            Dim excelRow As Integer = 0

            If exportHeaderCondition = True Then
                For i As Integer = 0 To C1List1.Columns.Count - 1
                    excelSheet(excelRow, i).Value = C1List1.Columns(i).Caption
                Next
                excelRow += 1
            End If

            For row As Integer = 0 To C1List1.ListCount - 1
                For col As Integer = 0 To C1List1.Columns.Count - 1
                    Dim cellValue As Object = C1List1.GetDisplayText(row, col)
                    excelSheet(excelRow, col).Value = cellValue
                Next
                excelRow += 1
            Next
        End If

        C1XLBook1.Save("C:\GeneratedReport.xls")
        Process.Start("C:\GeneratedReport.xls")

    End Sub

    Private Sub exportButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exportButton.Click

        If exportHeaderCheckBox.Checked Then
            ExportData(True)
        Else
            ExportData(False)
        End If


    End Sub
End Class


